#include <stdlib.h>
//#include "e:/WinAVR/avr-libc-1.4.6/libc/stdlib/stdlib_private.h"
#include "HeapManager.h"


#include <avr/io.h>

//size_t __malloc_margin = 32;
//char *__malloc_heap_start = &__heap_start;
//char *__malloc_heap_end = &__heap_end;

//char *__brkval;
//struct __freelist *__flp;

HEAP_BLOCK *pHeap;

void *malloc(size_t size)
{
	return HeapAlloc(pHeap,size);
}

void free(void *p)
{
	HeapFree(pHeap, p);
}

void OS_InitMalloc(char *start,char *end)
{
	//--------------------------------------------------------------------
	// Initialize semaphore used to block access to malloc and free
	// parameters:
	//	start.........start of heap
	//	end...........end of heap
	//
	// If start == 0, use default value
	// If end == 0, use default value
	//--------------------------------------------------------------------

	char *heap_start,*heap_end;

	if(start) heap_start = start; else heap_start = &__heap_start;
	if(end) heap_end = end; else heap_end = &__heap_end;
	pHeap = HeapInit(heap_start,heap_end);
}


unsigned int FreeMallocSpace(void)
{
	//----------------------------------
	// walk the free list and calculate
	// the number of free bytes
	//
	// A return value of 0 could mean
	// that malloc just hasn't been called
	// yet.
	//----------------------------------
	struct __freelist *pHF;
	size_t Free = 0;

	pHF = pHeap->__flp;

	while(pHF)
	{
		Free += pHF->sz;
		pHF = pHF->nx;
	}
	if (pHeap->BrkVal == 0)	pHeap->BrkVal = pHeap->Start;
	Free = (size_t)(pHeap->End - pHeap->BrkVal);
	return Free;
}
