#ifndef COMMPROTO__H
#define COMMPROTO__H

#include "task.h"
#include "curses.h"
#include "MessageQueue.h"
#include "cio.h"


//--------------------------------------------------
// data structures for ACK packets
//--------------------------------------------------

typedef struct _ackosc ACKOSC;

struct _ackosc {
	unsigned short Ch;	/*!< channel	*/
	unsigned long Freq;	/*!< Frequency	*/
};

typedef struct _evparams EVPARAMS;

struct _evparams {
	unsigned Attack;
	unsigned Decay;
	unsigned Sustain;
	unsigned Release;
};

#define LO(x)		(x & 0x0ff)
#define HI(x)		((x >> 8) & 0x0ff)


#define MON_STATE_IDLE			0
#define MON_STATE_COLLECT_SIZE	1
#define MON_STATE_COLLECTCMD	2
#define MON_STATE_COLLECTDATA	3


#define MM_TEST					1		//test message
#define MM_SYNTH_EN				2
#define MM_ARM_LA				3
#define MM_READ_LA				4
#define MM_SET_LA_TRIG			5
#define MM_GET_LA_TRIG			6
#define MM_SET_OSC_FREQ			7
#define MM_GET_OSC_FREQ			8
#define MM_SET_EV				9
#define MM_GET_EV				10
#define MM_SET_FLT_FREQ			11
#define MM_GET_FLT_FREQ			12
#define MM_SET_FLT_Q			13
#define MM_GET_FLT_Q			14
#define MM_RESET_LA				15
#define MM_STATUS_LA			16
#define MM_SETQUAL_LA			17
#define MM_GETQUAL_LA			18
#define MM_PEEK					19
#define MM_SINGLESTEP			20
#define MM_GETDEBUG				21
#define MM_EV_TRIGGER			22
#define MM_EV_STATUS			23
#define MM_SET_SSCHANNEL		24
#define MM_GET_SSCHANNEL		25

#define MM_OUT_ACK				1		//ACK
#define MM_OUT_NAK				2		//NAK

extern TCB TCom,TCmd;
extern int CommandPortHandle;
extern MESSAGE_QUEUE *MainMSG;

extern void MMSendAck(int Handle,unsigned short AckCMD,char Status,char *data,int l);
extern void InitCommProtocol(void);

#endif
