#ifndef VOICEMANAGER__H
#define VOICEMANAGER__H

typedef struct _voice{
	unsigned Unit;		//which of the 64 voices in use
	unsigned Note;		//note assigned to this voice
	unsigned Velocity;	//note velocity
	struct _voice *next,*prev;
}VOICE;


extern unsigned AllocateUnit(void);
extern VOICE *NewVoice(void);
extern void DeleteVoice(VOICE *pV);
extern unsigned long NoteToPitch(unsigned nNote);
extern void NoteOn(unsigned Note,unsigned Velocity);
extern void NoteOff(unsigned Note,unsigned Velocity);
extern void InsertNote(VOICE *pV);
extern VOICE *RemoveNote(unsigned note);
extern void InitVoice(void);
extern void TriggerVoice(VOICE *pV);
extern void TriggerVoiceOff(VOICE *pV);

#endif
