/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// /////////////////////////////////////////////////////////////////////////////////////////

#include "task.h"
#include "pq.h"

/*!
 * \file ExitInterrupt.c
 * \ingroup MultitaskingKernel
 */

/*@{*/

volatile int InterruptCount;	/*!< Keeps track of interrupt call depth	*/
volatile int Blocking;			/*!< Keeps track of Blocking depth<br>
									This variable is incremented in code
									when task switching needs to be
									inhibited, and decremented when
									task switching is desired.<br>
									I have not found a lot of use
									for this feature, and will probably
									just get rid of it someday.	*/

/*!
 * \fn void ExitInterrupt(void)                                                                    
 * \brief This function is called at the end of an interrupt                                                       
 *                                                                     
 * This function keeps track of the nesting level of interrupts        
 * If nesting level is == 0, then do a context swap to the highest     
 * priority task                                                       
 *                                                                     
 * WARNING!                                                            
 * 	Don't mess with this function, you will be sorry                   
 *  Adding any local variables or passed parameters                    
 *  Messes with the stack.  IrqSwap alters the stack and               
 *  if it is different from what it expects, it will mess              
 *  up the stack.                                                      
 *                                                                     
 * Hey, you don't even need to add any local variables, just add a     
 * Little bit more code and it will mess things up.  Always check      
 * the listing file to see how much might get pushed onto the stack	   
 *                                                                     
 * ExitInterrupt will alocate at least 4 bytes on the stack probably   
 * for sr, depending on how it does this.                              
 * Currently ExitInterrupt uses 4 bytes on the stack to save various   
 * registers that it doesn't really have to                            
 *                                                                     
 * Currently IrqSwap() needs to remove 6 bytes from stack for the	   
 * ATmega2561 or 4 bytes for the ATmega128 (using -O1,-O2,-O3 or -Os   
 *				                                                       
 */

void ExitInterrupt(void)
{
/*---------------------------------------------------------------------
*                                                                     *
* ExitInterrupt                                                       *
*                                                                     *
* This function keeps track of the nesting level of interrupts        *
* If nesting level is == 0, then do a context swap to the highest     *
* priority task                                                       *
*                                                                     *
* WARNING!                                                            *
* 	Don't mess with this function, you will be sorry                  *
*  Adding any local variables or passed parameters                    *
*  Messes with the stack.  IrqSwap alters the stack and               *
*  if it is different from what it expects, it will mess              *
*  up the stack.                                                      *
*                                                                     *
* Hey, you don't even need to add any local variables, just add a     *
* Little bit more code and it will mess things up.  Always check      *
* the listing file to see how much might get pushed onto the stack	  *
*                                                                     *
*                                                                     *
* ExitInterrupt will alocate at least 4 bytes on the stack probably   *
* for sr, depending on how it does this.                              *
* Currently ExitInterrupt uses 4 bytes on the stack to save various   *
* registers that it doesn't really have to                            *
*                                                                     *
* Currently IrqSwap() needs to remove 6 bytes from stack for the	  *
* ATmega2561 or 4 bytes for the ATmega128 (using -O1,-O2,-O3 or -Os   *
*				                                                      *
----------------------------------------------------------------------*/
	--InterruptCount;
	if(!InterruptCount && !Blocking)	//don't swap if nested
	{
		CurrentTask->TimeStamp = TStamp;
		Replace(&ActiveTasks,(void **)&NextTask,CurrentTask);
		if(NextTask != CurrentTask)
		{
			NextTask->TcbSwaps++;
			IrqSwap();	//interrupts will be re-enabled right after this
		}
	}
}

/*@}*/
