/////////////////////////////////////////////////////////////////////////////////////////////
// This file is compiled with WinAVR version 4.1.2
//
// These routines mess with the stack
//
// you must use either of these optimizations:
// -O1
// -O3
// -O2
//
// Whatever you do, do NOT use -O0....it will NOT work
//
// /////////////////////////////////////////////////////////////////////////////////////////

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "task.h"
#include "pq.h"
#include "HeapManager.h"



/***************************************************************************
** PostSemaphore (Unlock)
**
**		This function is used to incrment the value of a sempaphore
**		1. Check value of event flag
**		2. Increment event flag
**		3. If value is greater than or equal to 0, return
**		4. Else remove task in pending list and put it into the active task queue
**		5. return
**
** parameters:
**	e.................pointer to event control block for semaphore
**	Value.............Value to return to pending task (should be positive)
**
** return value: 0 = No Error, negative indicates error
***************************************************************************/

int PostSemaphore(ECB *e, int Value)	//signal semaphore availiable
{
	TCB *t;
	char sr;

	sr = Disable();
	if(e->EventCount < 32766)	//is it going to overflow??
	{
		if(e->EventCount >= 0)	//increment semaphore
		{
			++e->EventCount;
			Enable(sr);
		}
		else
		{
			++e->EventCount;
			if(e->task_h)				//is there really a task waiting?
			{
				t = e->task_h;		//get first task in
				e->task_h = t->next;       //remove from list
				t->next = (TCB *)0;
				t->status = Value;			//return this value
				Insert(&ActiveTasks,t);	//put task back onto active list
				Enable(sr);
				Yeild();
			}
			else
			{
				Enable(sr);
			}
		}
		return EVENT_NOERROR;
	}
	else
	{
		Enable(sr);
		return(EVENT_OVERFLOW);
	}
}

int PostSemaphoreIrq(ECB *e, int Value)	//signal semaphore availiable
{
	TCB *t;

	if(e->EventCount < 32766)	//is it going to overflow??
	{
		if(e->EventCount >= 0)	//increment semaphore
		{
			++e->EventCount;
		}
		else
		{
			++e->EventCount;
			if(e->task_h)				//is there really a task waiting?
			{
				t = e->task_h;		//get first task in
				e->task_h = t->next;       //remove from list
				t->next = (TCB *)0;
				t->status = Value;			//return this value
				Insert(&ActiveTasks,t);	//put task back onto active list
			}
		}
		return EVENT_NOERROR;
	}
	else
	{
		return(EVENT_OVERFLOW);
	}
}

int PostSemaphoreWithData(ECB *e, int Value,unsigned data)	//signal semaphore availiable
{
	TCB *t;
	int sr;

	sr = Disable();
	if(e->EventCount < 32766)	//is it going to overflow??
	{
		if(e->EventCount++ >= 0)	//increment semaphore
		{
			Enable(sr);
		}
		else
		{
			if(e->task_h)				//is there really a task waiting?
			{
				t = e->task_h;		//get first task in
				e->task_h = t->next;       //remove from list
				t->next = (TCB *)0;
				t->status = Value;			//return this value
				t->misc = data;				//and add this value in as well
				Insert(&ActiveTasks,t);	//put task back onto active list
				Enable(sr);
				Yeild();
			}
			else
			{
				Enable(sr);
			}
		}
		return EVENT_NOERROR;
	}
	else
	{
		Enable(sr);
		return(EVENT_OVERFLOW);
	}
}
