/*************************************************************************
**	C version of CIO
**	Copyright (c) 1991 Jim Patchell
**
**	This is the Central Input Output device handler.  This is probably
**	a lame attempt to make access to various I/O devices a little more
**	orthagonal.  Maybe, maybe not.
**
**  The interface function, cio only requires one parameter, but accepts
**	a variable number of parameters depending on the type of function
**	it is that is being executed.
**
**	The functions that can be executed are:
**
**		add handler
**		open
**		close
**		get
**		get record (read)
**		put
**		put record (write)
**		status
**		special command (xio)
**
**
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fcntl.h"
#include "cio.h"
#include "task.h"


int CioGetC(IOCB *I)
{
	/*
	** Get character from handler
	** called as:  cio(GETC,handle)
	*/
	if((I->mode & FCNTL_RDONLY) == 0)
		return(CIO_WRONLY);
	//
	// look up function
	//
	return ( (*htabs[I->ichid].HtabsEntry->getv)(I)  );
}

int CioRead(IOCB *I,char *b,int n)
{
	/*
	** Get a character buffer from handler
	** called as: cio(READ,handle,buffer,count)
	** driver function returns either an error or
	** actual number of bytes read
	*/
	if((I->mode & FCNTL_RDONLY) == 0)
		return(CIO_WRONLY);
	//
	//look up function
	//
	return (*htabs[I->ichid].HtabsEntry->readv)(I,b,n);
}
