// DisplayStatic.cpp : implementation file
//

#include "stdafx.h"
#include "DisplayStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisplayStatic

CDisplayStatic::CDisplayStatic()
{
	m_FifoStrings = 0;
	m_FifoSize = 0;
	m_FifoHead = 0;
	m_FifoTail = 0;
	m_nStrings = 0;
}

CDisplayStatic::~CDisplayStatic()
{
	if(m_FifoStrings)
		delete[] m_FifoStrings;
}


BEGIN_MESSAGE_MAP(CDisplayStatic, CStatic)
	//{{AFX_MSG_MAP(CDisplayStatic)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplayStatic message handlers

void CDisplayStatic::SetWindowText(LPCTSTR lpszString)
{
	//---------------------------------------------------
	// This function is used to add a string to a Static
	// Text box
	//---------------------------------------------------
	int l;
	char *s;
	AddString((char *)lpszString);
	l = GetTotalSize();
	s = new char[l];
	GenDisplayString(s);
	CStatic::SetWindowText(s);
	delete[] s;
}

int CDisplayStatic::AddString(char *s)
{
	int l;
	char *S;

	l = strlen(s);
	S = new char[l+1];
	strcpy(S,s);
	if(m_nStrings == m_FifoSize)	//is it full yet?
	{
		delete[] m_FifoStrings[m_FifoTail];
		m_FifoTail++;
		if(m_FifoTail == m_FifoSize) m_FifoTail = 0;
		--m_nStrings;
	}
	m_FifoStrings[m_FifoHead++] = S;
	if(m_FifoHead == m_FifoSize) m_FifoHead = 0;
	++m_nStrings;
	return m_nStrings;
}

int CDisplayStatic::GenDisplayString(char *pDispString)
{
	//----------------------------------------------------
	// Concatanate all of the strings togheter
	// use a '\n' char between strings
	//
	// parameter:
	//	pDispString......pointer to dest, must be big
	//					enough for total size of strings
	//----------------------------------------------------

	int l=0,i,t;

	t = m_FifoTail;
	for(i=0;i<m_nStrings;++i)
	{
		l += sprintf(&pDispString[l],"%s\n",m_FifoStrings[t]);
		++t;
		if(t == m_nStrings) t = 0;
	}
	return m_nStrings;
}

int CDisplayStatic::GetTotalSize()
{
	int rv = 0;

	int i;
	int h = m_FifoTail;

	for(i=0;i<m_nStrings;++i)
	{
		rv += strlen(m_FifoStrings[h]) + 2;		//add a fudge factor
		h++;
		if(h == m_FifoSize) h = 0;
	}
	return rv;
}

void CDisplayStatic::InitStringFifo(int n)
{	
	int i;

	m_FifoStrings = new char *[n];
	for(i=0;i<n;++i)
		m_FifoStrings[i] = 0;
	m_FifoSize = n;

}
