// LogicAnl.cpp : implementation file
//

#include "stdafx.h"
#include "synthconsol.h"
#include "LogicAnl.h"
#include "WindowMessages.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogicAnl dialog


CLogicAnl::CLogicAnl(CWnd* pParent /*=NULL*/)
	: CDialog(CLogicAnl::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLogicAnl)
	//}}AFX_DATA_INIT
	m_pMQ = new CMsgQueue(64);
	m_PlotIndex = 0;
}


void CLogicAnl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogicAnl)
	DDX_Control(pDX, IDC_SB_PLOT, m_SB_Plot);
	DDX_Control(pDX, IDC_STATIC_PLOT, m_Static_Plot);
	DDX_Control(pDX, IDC_EDIT_QUALIFIER, m_Edit_Qaulifier);
	DDX_Control(pDX, IDC_EDIT_LA_READ, m_Edit_Read);
	DDX_Control(pDX, IDC_STATIC_DISPLAY, m_Static_Display);
	DDX_Control(pDX, IDC_EDIT_TRIGWORD, m_EditTrigWord);
	DDX_Control(pDX, IDC_STATIC_LADB, m_Static_db);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLogicAnl, CDialog)
	//{{AFX_MSG_MAP(CLogicAnl)
	ON_BN_CLICKED(IDC_BUTTON_SET_TRIG, OnButtonSetTrig)
	ON_BN_CLICKED(IDC_BUTTON_ARM, OnButtonArm)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	ON_BN_CLICKED(IDC_BUTTON_LA_RESET, OnButtonLaReset)
	ON_BN_CLICKED(IDC_BUTTON_STATUS, OnButtonStatus)
	ON_BN_CLICKED(IDC_BUTTON_QUALIFIER, OnButtonQualifier)
	ON_BN_CLICKED(IDC_BUTTON_GETQUAL, OnButtonGetqual)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_LA_DATA,OnLaData)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLogicAnl message handlers

BOOL CLogicAnl::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_Static_db.InitStringFifo(7);
	m_Static_Display.InitStringFifo(12);
	//--------------------------------------------
	// initialize plot control
	//--------------------------------------------
	m_Static_Plot.InitPlot(512);
	m_Static_Plot.Test(&m_Static_db);
	m_Static_Plot.AddScrollBar(&m_SB_Plot);
	m_Static_Plot.SetScale(32767,-32768);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLogicAnl::OnOK() 
{
	// TODO: Add extra validation here
	
	CWnd *wC;

	wC = GetFocus();					//get handle of control that generated message
	int id = wC->GetDlgCtrlID();		//get ID of control
	switch(id)							//parse the id
	{
		case IDOK:
			CDialog::OnOK();
			break;
		default:
			wC = GetNextDlgTabItem(wC);	//reset the focus
			wC->SetFocus();
			break;
	}
}

void CLogicAnl::OnButtonSetTrig() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	char *tw = new char[16];
	int i;
	int l;
	int j;
	int shift;

	m_EditTrigWord.GetWindowText(s,256);
	m_Static_db.SetWindowText(s);
	//parse trigger word
	l = strlen(s);
	if(l > 32) l = 32;
	memset(tw,0,8);
	for(i=0;i<l;++i)
	{
		j = i >> 2;		//divide by 4
		shift = (i & 0x03) << 1;

		switch(s[i])
		{
			case 'x':
			case 'X':
				break;	//do nothing on don't care
			case '0':
				tw[j] |= (0x2) << shift;
				break;
			case '1':
				tw[j] |= (0x3) << shift;
				break;
			default:
				sprintf(s,"Illegal Char @ %d",i);
				m_Static_db.SetWindowText(s);
				break;
		}
	}
	sprintf(s,"%02x %02x %02x %02x %02x %02x %02x %02x",tw[0] & 0x0ff,tw[1] & 0x0ff,tw[2] & 0x0ff,tw[3] & 0x0ff,tw[4] & 0x0ff,tw[5] & 0x0ff,tw[6] & 0x0ff,tw[7] & 0x0ff);
	m_Static_db.SetWindowText(s);
	pSP->SendLATrigger(tw);
	delete[] tw;
	delete[] s;
}

void CLogicAnl::OnButtonArm() 
{
	// TODO: Add your control notification handler code here
	pSP->SendLAarm();		//arm logic analyzer
}

void CLogicAnl::OnButtonRead() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	m_Edit_Read.GetWindowText(s,256);
	int n = atoi(s);
	pSP->SendLAReadData(n);
	delete[] s;
}

void CLogicAnl::OnButtonLaReset() 
{
	// TODO: Add your control notification handler code here
	pSP->SendLaReset();
	m_PlotIndex = 0;
}

void CLogicAnl::OnButtonStatus() 
{
	// TODO: Add your control notification handler code here
	pSP->SendLaStatus();
}

void CLogicAnl::OnButtonQualifier() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	m_Edit_Qaulifier.GetWindowText(s,256);
	unsigned short nUS = (unsigned short)strtoul(s,NULL,16);
	pSP->SendLaSetQualifier(nUS);
	delete[] s;
}

void CLogicAnl::OnButtonGetqual() 
{
	// TODO: Add your control notification handler code here
//	pSP->SendLaGetQualifier();
	int i;
	short x;
	for(i=0,x=0;i<512;++i,x += 1023)
	{
		m_Static_Plot.AddPoint(i,x);
	}
}

LRESULT CLogicAnl::OnLaData(WPARAM w, LPARAM l)
{
	AMSG *pMsg;
	short x;

	pMsg = m_pMQ->Remove();		//remove message from queue
	char *s = new char[256];
	int n = pMsg->PayloadSize / sizeof(long);
	sprintf(s,"Got %d words",n);
	m_Static_Display.SetWindowText(s);
	int i;
	long *pL = (long *)pMsg->Payload;
	for(i=0;i<n;++i)
	{
		x = (short)(pL[i] & 0x0ffff);
		sprintf(s,"%08lx",pL[i]);
		m_Static_Display.SetWindowText(s);
		m_Static_Plot.AddPoint(m_PlotIndex++,(int)x);
	}
	if(m_PlotIndex < 1024)
	{
		char *s = new char[256];
		m_Edit_Read.GetWindowText(s,256);
		int n = atoi(s);
		pSP->SendLAReadData(n);
		delete[] s;
	}
	return 0;
}


