// SingleStep.cpp : implementation file
//

#include "stdafx.h"
#include "synthconsol.h"
#include "SingleStep.h"
#include "WindowMessages.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSingleStep dialog


CSingleStep::CSingleStep(CWnd* pParent /*=NULL*/)
	: CDialog(CSingleStep::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSingleStep)
	//}}AFX_DATA_INIT
	m_pSP = 0;
}


void CSingleStep::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSingleStep)
	DDX_Control(pDX, IDC_EDIT_SS_CHANNEL, m_Edit_Channel);
	DDX_Control(pDX, IDC_STATIC_SS_VCA, m_Static_VCA);
	DDX_Control(pDX, IDC_STATIC_SS_OSC, m_Static_Osc);
	DDX_Control(pDX, IDC_STATIC_SS_FILT, m_Static_Filt);
	DDX_Control(pDX, IDC_STATIC_SS_EV2, m_Static_Ev2);
	DDX_Control(pDX, IDC_STATIC_SS_EV1, m_Static_Ev1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSingleStep, CDialog)
	//{{AFX_MSG_MAP(CSingleStep)
	ON_BN_CLICKED(IDC_BUTTON_SS_STEP, OnButtonSsStep)
	ON_BN_CLICKED(IDC_BUTTON_SS_CHANNEL, OnButtonSsChannel)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SS_DEBUGDATA,OnDebugData)
	ON_MESSAGE(WM_SS_STEPED,OnStep)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSingleStep message handlers

BOOL CSingleStep::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_Static_Ev1.InitStringFifo(5);
	m_Static_Ev2.InitStringFifo(5);
	m_Static_Filt.InitStringFifo(5);
	m_Static_Osc.InitStringFifo(5);
	m_Static_VCA.InitStringFifo(8);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSingleStep::OnOK() 
{
	// TODO: Add extra validation here
	ShowWindow(0);
	
	CDialog::OnOK();
}

void CSingleStep::OnButtonSsStep() 
{
	// TODO: Add your control notification handler code here
	if(m_pSP) m_pSP->SendSingleStep();
}

LRESULT CSingleStep::OnDebugData(WPARAM w, LPARAM l)
{
	AMSG *pM = m_pSingleStepMessage->Remove();
	char *s = new char[256];
	SYNTH_DEBUG *pSD = (SYNTH_DEBUG *)pM->Payload;
	sprintf(s,"%04x",pSD->OSC);
	m_Static_Osc.SetWindowText(s);
	sprintf(s,"%04x",pSD->EV1);
	m_Static_Ev1.SetWindowText(s);
	sprintf(s,"%04x",pSD->EV2);
	m_Static_Ev2.SetWindowText(s);
	sprintf(s,"%04x",pSD->FILT);
	m_Static_Filt.SetWindowText(s);
	sprintf(s,"CH=%04x %04x",pSD->Channel & 0x0ffff,pSD->VCA);
	m_Static_VCA.SetWindowText(s);
	delete[] s;
	DeleteAMSG(pM);
	return 0;
}

LRESULT CSingleStep::OnStep(WPARAM w, LPARAM l)
{
	if(m_pSP) m_pSP->SendGetDebugData();
	return 0;
}

void CSingleStep::OnButtonSsChannel() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	m_Edit_Channel.GetWindowText(s,256);
	unsigned short ch = atoi(s);
	if(m_pSP) m_pSP->SendSingleStepSetChannel(ch);
	delete[] s;
}
