#if !defined(AFX_SYNTH_H__D6074C3A_FE21_402D_93E4_202BB80C998B__INCLUDED_)
#define AFX_SYNTH_H__D6074C3A_FE21_402D_93E4_202BB80C998B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Synth.h : header file
//

#include "DisplayStatic.h"
#include "SynthPort.h"
#include "HorzScrollBar.h"
#include "EVparams.h"

struct EVbank {
	CHorzScrollBar *pAttack;
	CHorzScrollBar *pDecay;
	CHorzScrollBar *pSustain;
	CHorzScrollBar *pRelease;
};

/////////////////////////////////////////////////////////////////////////////
// CSynth dialog

class CSynth : public CDialog
{
// Construction
public:
	void InitEvParams(EVbank *pEvB,EVparams *pEvP);
	unsigned short ScaleTimeConstant(int v);
	EVparams *m_pEVparams;
	EVbank m_EVbank[2];
	void FillInEVparam(int b,EVparams *pEV);
	double logb(double x, double b);
	int FrequencyToPitch(long Freq);
	CSynthPort * m_pSynthPort;
	unsigned long PitchToFrequency(int pitch);
	CSynth(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSynth)
	enum { IDD = IDD_DIALOG_SYNTH_SETUP };
	CStatic	m_Static_Flt_Res;
	CStatic	m_Static_Flt_Freq;
	CHorzScrollBar	m_SB_Flt_Res;
	CHorzScrollBar	m_SB_Flt_Freq;
	CStatic	m_Static_Release2;
	CStatic	m_Static_Sustain2;
	CStatic	m_Static_Decay2;
	CStatic	m_Static_Attack2;
	CHorzScrollBar	m_ScrollBar_Sustain2;
	CHorzScrollBar	m_ScrollBar_Release2;
	CHorzScrollBar	m_ScrollBar_Decay2;
	CHorzScrollBar	m_ScrollBar_Attack2;
	CButton	m_Check_Trigger2;
	CButton	m_Check_Trigger;
	CStatic	m_Static_Release;
	CStatic	m_Static_Sustain;
	CStatic	m_Static_Decay;
	CStatic	m_Static_Attack;
	CHorzScrollBar	m_ScrollBar_Release;
	CHorzScrollBar	m_ScrollBar_Sustain;
	CHorzScrollBar	m_ScrollBar_Decay;
	CHorzScrollBar	m_ScrollBar_Attack;
	CStatic	m_Static_Pitch;
	CHorzScrollBar	m_SB_Pitch;
	CHorzScrollBar	m_Scrollbar_Channel;
	CStatic	m_Static_Channel;
	CDisplayStatic	m_Static_Debug;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSynth)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	LRESULT OnFltResonance(WPARAM w, LPARAM l);
	LRESULT OnSustain1(WPARAM w, LPARAM l);
	LRESULT OnDecay2(WPARAM w, LPARAM l);
	LRESULT OnDecay1(WPARAM w, LPARAM l);
	LRESULT OnAttack2(WPARAM w, LPARAM l);
	LRESULT OnAttack1(WPARAM w, LPARAM l);
	LRESULT OnFltFreq(WPARAM w, LPARAM l);
	LRESULT OnRelease2(WPARAM w, LPARAM l);
	LRESULT OnRelease1(WPARAM w, LPARAM l);
	LRESULT OnSustain2(WPARAM w, LPARAM l);
	LRESULT OnOscFreq(WPARAM channel, LPARAM freq);
	LRESULT OnChannelChange(WPARAM wparam, LPARAM lparam);
	LRESULT OnPitchChange(WPARAM wparam, LPARAM lparam);

	// Generated message map functions
	//{{AFX_MSG(CSynth)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnCheckTrigger();
	afx_msg void OnCheckTrigger2();
	afx_msg void OnButtonSynthSuZeroOsc();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYNTH_H__D6074C3A_FE21_402D_93E4_202BB80C998B__INCLUDED_)
