// SynthConsolDlg.h : header file
//

#if !defined(AFX_SYNTHCONSOLDLG_H__9109082F_80AE_465C_9F20_869833580850__INCLUDED_)
#define AFX_SYNTHCONSOLDLG_H__9109082F_80AE_465C_9F20_869833580850__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DisplayStatic.h"
#include "MyHeap.h"
#include "MSG.h"
#include "OverlappedSerial.h"
#include "SynthPort.h"
#include "WindowMessages.h"
#include "SerialSetup.h"
#include "LogicAnl.h"
#include "Synth.h"
#include "SingleStep.h"

/////////////////////////////////////////////////////////////////////////////
// CSynthDlg dialog

class CSynthDlg : public CDialog
{
// Construction
public:
	CMsgQueue * m_pSingleStepMessage;
	CSingleStep * m_pSingleStepDlg;
	CLogicAnl * m_pLA;
	CSynth * m_pSynthDlg;
	unsigned short TCount;
	LRESULT DecodePacket(WPARAM wparam, LPARAM lparam);
	int m_TestCommand_AutoResponse;
	int mAckCount;
	CMsgQueue * m_pMQ;
	int m_ComPort;
	int m_BaudRate;
	int m_SerialPortMode;
	CSynthPort * m_pSynthPort;
	COverlappedSerial * pComPort;
	int ParseAckMessage(char *s, int n);
	int ParseMessage(AMSG *msg);
	void HexDump(CDisplayStatic *disp, char *m, int n);
	int OpenSerialPort(int BRate, int ComPort);
	CMyHeap * m_Heap;
	CSynthDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSynthDlg)
	enum { IDD = IDD_SYNTHCONSOL_DIALOG };
	CHexEdit	m_Edit_PeekAddress;
	CStatic	m_Static_Peek;
	CButton	m_Check_EnableSynth;
	CButton	m_Check_AutoResponse;
	CEdit	m_Edit_TestString;
	CDisplayStatic	m_Static_Display;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSynthDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	LRESULT OnCommThreadStopped(WPARAM wparam, LPARAM lparam);
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSynthDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnButtonSerialSetup();
	afx_msg void OnButtonTestcmd();
	afx_msg void OnCheckAutoresponse();
	afx_msg void OnButtonLogicAnalyzer();
	afx_msg void OnCheckEnableSynth();
	afx_msg void OnButtonSetupSynth();
	afx_msg void OnButtonPeek();
	afx_msg void OnButtonSingleStep();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYNTHCONSOLDLG_H__9109082F_80AE_465C_9F20_869833580850__INCLUDED_)
