`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    19:54:59 09/28/2008 
// Design Name: 
// Module Name:    EVstatemachine 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module EVstatemachine(clk, reset, CS, C, A, E, CSstat, wdCSR, D, oD, EvO);
    input clk;
    input reset;
    output [2:0] CS;
    input [8:0] C;
    input [8:0] A;
    input E;
    output [2:0] CSstat;
	input wdCSR;
	input D;
	output oD;
	input [15:0] EvO;

	wire oD;
	wire [2:0] CSstat;
	
	parameter STATE_RELEASE	=	3'b001;	//release state
	parameter STATE_ATTACK	=	3'b010;	//attack state
	parameter STATE_DECAY	=	3'b100;	//Decay State

	reg [2:0] NS;
	reg [8:0] Cd;
	reg [2:0] CS;
	wire [2:0] CSdat;
	reg Trig;
	wire TrigDat;
	
	reg Ed;
	
	always @ (posedge clk or posedge reset)
		if(reset)
			Ed <= 0;
		else
			Ed <= E;
			
	always @ (posedge clk or posedge reset)
		if(reset)
			Cd <= 0;
		else
			Cd <= C;
/*
input [8 : 0] a;
input [1 : 0] d;
input [8 : 0] dpra;
input clk;
input we;
output [1 : 0] spo;
output [1 : 0] dpo;
*/

DualPortRam512x3 State (
	.a(Cd),
	.d(NS),
	.dpra(C),
	.clk(clk),
	.we(Ed),
	.spo(),
	.dpo(CSdat)
    );

	always @ (posedge clk) CS <= CSdat;
		
DualPortRam512x3 StateStat (
	.a(C),
	.d(NS),
	.dpra(A[8:0]),
	.clk(clk),
	.we(Ed),
	.spo(),
	.dpo(CSstat)
);

/*
input [8 : 0] a;
input [0 : 0] d;
input [8 : 0] dpra;
input clk;
input we;
output [0 : 0] spo;
output [0 : 0] dpo;
*/

DualPortRam512x1 Trigger(
    .a(A), 
    .d(D), 
    .dpra(C), 
    .clk(clk), 
    .we(wdCSR), 
    .spo(oD), 
    .dpo(TrigDat)
    );

always @ (posedge clk) Trig <= TrigDat;

//---------------------------------
// State machine
//---------------------------------

always @ (CS or Trig or EvO) begin
 case (CS)
	STATE_RELEASE: begin
		if(Trig) begin
			NS = STATE_ATTACK;
		end
		else begin
			NS = STATE_RELEASE;
		end
	end
	STATE_ATTACK: begin
		if(EvO > 16'hff00) begin
			NS = STATE_DECAY;
		end
		else begin
			NS = STATE_ATTACK;
		end
	end
	STATE_DECAY: begin
		if(Trig) begin
			NS = STATE_DECAY;
		end
		else begin
			NS = STATE_RELEASE;
		end
	end
	default: begin
		NS = STATE_RELEASE;
	end
 endcase
end

endmodule
