`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:10:26 10/01/2008 
// Design Name: 
// Module Name:    Mixer 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Mixer(clk, E, C, I, EV, O);
    input clk;
    input E;
	 input [8:0] C;
    input [15:0] I;
    input [15:0] EV;
    output [15:0] O;

	wire [33:0] VcaO;
//	wire [39:0] Accum;	//final mixer accumulator
	wire [33:0] Accum;	//final mixer accumulator
	reg [15:0] O;
	reg clr_ld;
	
always @ (E or C)
	if((C == 9'b111111111) && E)
		clr_ld = 1;
	else
		clr_ld = 0;
		
MultS17x17 VCA (
    .clk(clk),
    .a({I[15],I}), // Bus [16 : 0] 
    .b({1'b0,EV}), // Bus [16 : 0] 
    .p(VcaO)); // Bus [33 : 0] 


Accum34 Accumulator (
    .B(VcaO[31:0]), // Bus [31 : 0] 
    .Q(Accum), // Bus [33 : 0] 
    .CLK(clk),
    .CE(E),
    .SCLR(clr_ld));

/* 
Accum36 Accumulator (
    .B(VcaO[31:0]), // Bus [31 : 0] 
    .Q(Accum), // Bus [35 : 0] 
    .CLK(clk),
    .CE(E),
    .SCLR(clr_ld));
*/
 
/*		
Accum40 Accumulator (
    .B(VcaO[31:0]), // Bus [31 : 0] 
    .Q(Accum), // Bus [39 : 0] 
    .CLK(clk),
    .CE(E),
    .SCLR(clr_ld));
*/

always @ (posedge clk)
	if(clr_ld)
		O <= Accum[33:18];


endmodule
