`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    20:42:16 06/17/2008 
// Design Name: 
// Module Name:    Osciclator 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: DDS module  (i.e.  THe VCOs dude....
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Osciclator(clk, reset, O, C, E, din, dout, wd, A);
    input clk;					//system clock
    input reset;				//system reset
    output [15:0] O;			//module output (oscilators)
    input [8:0] C;			//channel address
	 input E;					//Enable Oscillator
    input [7:0] din;			//data bus from AVR
    output [7:0] dout;		//data bus to AVR
    input wd;					//write data from AVR
    input [10:0] A;			//address bus from AVR

	wire [31:0] PhaseO,FreqO,PhaseI;
	reg Ed;		//enable delayed 1 clock
	reg [8:0] Cd;	//channel number delayed by 1 clock
	
	always @ (posedge clk)
		Ed <= E;		//delay enable signal by 1 clock
		
	always @ (posedge clk)
		Cd <= C;		//delay channel number by one clock
		
/*-----------------------
input clka;
input [7 : 0] dina;
input [10 : 0] addra;
input [0 : 0] wea;
output [7 : 0] douta;
input clkb;
input [31 : 0] dinb;
input [8 : 0] addrb;
input [0 : 0] web;
output [31 : 0] doutb;
------------------------*/

dpram512x32x8 VcoFreq(
	.clka(clk),
	.dina(din),
	.addra(A),
	.wea(wd),
	.douta(dout),
	.clkb(clk),
	.dinb(32'b0),
	.addrb(C),
	.web(1'b0),
	.doutb(FreqO)
);

/*----------------------------
input clka;
input [31 : 0] dina;
input [8 : 0] addra;
input [0 : 0] wea;
output [31 : 0] douta;
input clkb;
input [31 : 0] dinb;
input [8 : 0] addrb;
input [0 : 0] web;
output [31 : 0] doutb;
----------------------------*/

dpram512x32 PhaseAcc(
	.clka(clk),
	.dina(PhaseI),
	.addra(Cd),
	.wea(Ed),
	.douta(),
	.clkb(clk),
	.dinb(32'b0),
	.addrb(C),
	.web(1'b0),
	.doutb(PhaseO)
);

assign O = PhaseO[31:16];

/*--------------------
input [31 : 0] A;
input [31 : 0] B;
output [31 : 0] S;
---------------------*/

Adder32 PhaseAdd(
	.A(FreqO),
	.B(PhaseO),
	.S(PhaseI)
);

endmodule
