`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:30:36 10/25/2006 
// Design Name: 
// Module Name:    TopLevel 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module TopLevel(clkin, wd, rd, ale, ad, a, led,ledseg,leddig,irq,tirq,H,V,R,G,B,rmD,rAO,rCE1,rLB1,rUB1,rCE2,rUB2,rLB2,rWE,rOE,rxd,txd,uartIrq,mck, sck, lrck, sd,MidiIn,MidiOut);
    input clkin;
    input wd;
    input rd;
    input ale;
//	 input reset;
    inout [7:0] ad;
    input [7:0] a;
    output [7:0] led;
	output [6:0] ledseg;
	output [3:0] leddig;
	output irq;
	output tirq;
	output H,V,R,G,B;
	inout [31:0]rmD;
	output [17:0]rAO;
	output rCE1,rLB1,rUB1,rCE2,rUB2,rLB2,rWE,rOE;
	input rxd;
	output txd,uartIrq;
	output mck, sck, lrck, sd;
	input MidiIn;
	output MidiOut;
	
	wire 	mck, sck, lrck, sd;
	wire tirq;
	wire irq;
	wire [3:0]la,ea;
	wire [7:0] din;
	wire [7:0] d;
	wire [6:0]ledseg;
	wire [3:0] leddig;
	wire clk;
	
	//----------------------------
	// 4 digit LED display
	//----------------------------
	reg [7:0] selcntr;

	//------------------------------
	// Ram Interface
	//------------------------------
	
	wire [31:0] rDI,rDO;
	wire [17:0] rAO;
	wire rCE1,rLB1,rUB1,rCE2,rUB2,rLB2,rWE,rOE;
	wire rboe;
	
avrif AvrInterface (
    .clk(clk), 
    .reset(), 
    .ad(din), 
    .d(d),		//output data 
    .a(a), 
    .ale(ale), 
    .wd(wd), 
    .rd(rd), 
    .oen(oen), 
	 .la(la),
	 .led(led),
	 .EA(ea),
	 .irq(irq),
	 .tirq(tirq),
    .H(H), 
    .V(V), 
    .R(R), 
    .G(G), 
    .B(B),
	 .rDI(rDI),
	 .rDO(rDO),
	 .rAO(rAO),
	 .rCE1(rCE1),
	 .rLB1(rLB1),
	 .rUB1(rUB1),
	 .rCE2(rCE2),
	 .rUB2(rUB2),
	 .rLB2(rLB2),
	 .rWE(rWE),
	 .rOE(rOE),
	 .rboe(rboe),
	 .rxd(rxd),
	 .txd(txd),
	 .uartIrq(uartIrq),
	 .mck(mck),
	 .sck(sck),
	 .lrck(lrck),
	 .sd(sd),
	 .MidiIn(MidiIn),
	 .MidiOut(MidiOut)
    );

IOBUF Io0 (
      .O(din[0]),     // Buffer output
      .IO(ad[0]),   // Buffer inout port (connect directly to top-level port)
      .I(d[0]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io1 (
      .O(din[1]),     // Buffer output
      .IO(ad[1]),   // Buffer inout port (connect directly to top-level port)
      .I(d[1]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io2 (
      .O(din[2]),     // Buffer output
      .IO(ad[2]),   // Buffer inout port (connect directly to top-level port)
      .I(d[2]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io3 (
      .O(din[3]),     // Buffer output
      .IO(ad[3]),   // Buffer inout port (connect directly to top-level port)
      .I(d[3]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io4 (
      .O(din[4]),     // Buffer output
      .IO(ad[4]),   // Buffer inout port (connect directly to top-level port)
      .I(d[4]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io5 (
      .O(din[5]),     // Buffer output
      .IO(ad[5]),   // Buffer inout port (connect directly to top-level port)
      .I(d[5]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io6 (
      .O(din[6]),     // Buffer output
      .IO(ad[6]),   // Buffer inout port (connect directly to top-level port)
      .I(d[6]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

IOBUF Io7 (
      .O(din[7]),     // Buffer output
      .IO(ad[7]),   // Buffer inout port (connect directly to top-level port)
      .I(d[7]),     // Buffer input
      .T(oen)      // 3-state enable input 
);

	//-------------------------------------------------------------------
	// External Ram Interface
	//-------------------------------------------------------------------
	
IOBUF RIo0 (
		.O(rDI[0]),
		.IO(rmD[0]),
		.I(rDO[0]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo1 (
		.O(rDI[1]),
		.IO(rmD[1]),
		.I(rDO[1]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo2 (
		.O(rDI[2]),
		.IO(rmD[2]),
		.I(rDO[2]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo3 (
		.O(rDI[3]),
		.IO(rmD[3]),
		.I(rDO[3]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo4 (
		.O(rDI[4]),
		.IO(rmD[4]),
		.I(rDO[4]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo5 (
		.O(rDI[5]),
		.IO(rmD[5]),
		.I(rDO[5]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo6 (
		.O(rDI[6]),
		.IO(rmD[6]),
		.I(rDO[6]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo7 (
		.O(rDI[7]),
		.IO(rmD[7]),
		.I(rDO[7]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo8 (
		.O(rDI[8]),
		.IO(rmD[8]),
		.I(rDO[8]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo9 (
		.O(rDI[9]),
		.IO(rmD[9]),
		.I(rDO[9]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo10 (
		.O(rDI[10]),
		.IO(rmD[10]),
		.I(rDO[10]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo11 (
		.O(rDI[11]),
		.IO(rmD[11]),
		.I(rDO[11]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo12 (
		.O(rDI[12]),
		.IO(rmD[12]),
		.I(rDO[12]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo13 (
		.O(rDI[13]),
		.IO(rmD[13]),
		.I(rDO[13]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo14 (
		.O(rDI[14]),
		.IO(rmD[14]),
		.I(rDO[14]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo15 (
		.O(rDI[15]),
		.IO(rmD[15]),
		.I(rDO[15]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo16 (
		.O(rDI[16]),
		.IO(rmD[16]),
		.I(rDO[16]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo17 (
		.O(rDI[17]),
		.IO(rmD[17]),
		.I(rDO[17]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo18 (
		.O(rDI[18]),
		.IO(rmD[18]),
		.I(rDO[18]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo19 (
		.O(rDI[19]),
		.IO(rmD[19]),
		.I(rDO[19]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo20 (
		.O(rDI[20]),
		.IO(rmD[20]),
		.I(rDO[20]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo21 (
		.O(rDI[21]),
		.IO(rmD[21]),
		.I(rDO[21]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo22 (
		.O(rDI[22]),
		.IO(rmD[22]),
		.I(rDO[22]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo23 (
		.O(rDI[23]),
		.IO(rmD[23]),
		.I(rDO[23]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo24 (
		.O(rDI[24]),
		.IO(rmD[24]),
		.I(rDO[24]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo25 (
		.O(rDI[25]),
		.IO(rmD[25]),
		.I(rDO[25]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo26 (
		.O(rDI[26]),
		.IO(rmD[26]),
		.I(rDO[26]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo27 (
		.O(rDI[27]),
		.IO(rmD[27]),
		.I(rDO[27]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo28 (
		.O(rDI[28]),
		.IO(rmD[28]),
		.I(rDO[28]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo29 (
		.O(rDI[29]),
		.IO(rmD[29]),
		.I(rDO[29]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo30 (
		.O(rDI[30]),
		.IO(rmD[30]),
		.I(rDO[30]),
		.T(rboe)	//enable tristate buffer on Write Data
);

IOBUF RIo31 (
		.O(rDI[31]),
		.IO(rmD[31]),
		.I(rDO[31]),
		.T(rboe)	//enable tristate buffer on Write Data
);

	//-------------------------------------------------------------------
	// 4 digit LED display for DEBUG
	//-------------------------------------------------------------------
	always @ (posedge clk)
		selcntr <= selcntr + 1;
		
	leddisplay leddisp1(
		.ain(la),
		.bin(ea),
		.cin(4'b0),
		.din(4'b0),
		.led(ledseg),
		.sel(selcntr[7:6]),
		.dig(leddig)
);

   BUFG BUFG1 (
      .O(clk),     // Clock buffer output
      .I(clkin)      // Clock buffer input
   );

endmodule
